import { globalStyle, globalLookup, globalSetting } from '../global';

const yOffsetUpdate = (pstate, nextOffsetYFn) => {
    let nextOffsetY = nextOffsetYFn();
    const { width, xOffset, xScale, time, sidebarWidth } = pstate;

    nextOffsetY = nextOffsetY;

    const currentRenderHeight = globalLookup.currentWires.size * pstate.yStep;
    const canvasHeight = pstate.height - pstate.topBarHeight - pstate.botBarHeight;
    // console.log(currentRenderHeight, canvasHeight);
    const maxOffsetY = Math.max(-20,
                                currentRenderHeight - canvasHeight); // maximum offset
    nextOffsetY = Math.min(nextOffsetY, maxOffsetY);

    const minOffsetY = -20; // minimum offset
    nextOffsetY = Math.max(nextOffsetY, minOffsetY);
    
    // if (nextOffsetY === xOffset) {
    //     return false; // exit without scroll
    // }
    
    pstate.oldYOffset = pstate.yOffset;
    pstate.yOffset = nextOffsetY;

    // 这玩意儿初始设置 -20 的偏移，当作 padding-top
    globalStyle.yOffset = nextOffsetY + 20;
    return true;
};

export default yOffsetUpdate;